{***************************************************************}
{                                                               }
{   TDateTimePicker component                                   }
{   Date:    Sep, 23 1996                                       }
{   Version: 0.2 bate                                           }
{   Author:  Andy Lee Yiu                                       }
{   System:  Delphi 2.0 with MS IE 3.0 or greater installed     }
{                                                               }
{   E-Mail: andylee@hkstar.com                                  }
{   This is a postcardware, if you are enjoy this product,      }
{   please send the postcard to the following address           }
{   "Flat 2D 23/F Treasury Tower, Shatin, N.T. Hong Kong"       }
{***************************************************************}
{
  TDateTimePicker is a customizable calendar and time control,
  subclass the new common control shipped with MS IE 3.0, that allow users
  select a date or time in the control. this control has two operation modes
  Date mode: as a combobox like control, user can drop down monthly calendar
             by Setting the DateTimeStyle property to dtLongDate or dtShortDate
             and the DateUpdown property to False, if True, it show the up down
             button insteat of drop down monthly calendar.

             if monthly calendar mode is set, user can change the calendar color
             by the CalendarBackground, CalendarText, CalendarTitleBK,
             CalendarTitleText, CalendarMonthBK, CalendarTrailingText property.

  Time mode: as a updown edit control the time editing by set the DateTimeStyle
             property to dtTime.

  User can set AppCanParse to set editing control for both modes and set the
  display format by the format property.


  Runtime properties:
    SystemTime : TDatetime ; get ot set the control date time;
    CalenlarHandle : THandle ; return the MonthlyCalendar control handle
                               * MonthlyCalendar with implement later.

 30, sep 1996 Version 0.2 bate
 1. Add Min Date / Max Date    // Max does't work correctly
 2. Add event OnDateTimeChange, OnCloseUp, OnDropDown;

 09, Oct 1996 Version 0.2.1 Bate
 1. Fixed the bug when using SystemTime occur valid error by setting the
    Regional Date to format as 'dd/MM/yy'
    the old result is using "StrtoDateTime(str)" but when changed the Regional
    Date format as 'dd/MM/yy', the parameter str must be set as the new format.
    Now I'm change to using encodeDate and encodeTime to solve the problem.
    result := encodeDate;
    result := result + encodeTime;

}
unit DateTimeEx;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ComCtrls,
  CommCtrlEx;

type
  TCalendarAlign = (caLeft, caRight);
  TDateTimeStyle  = (dtLongDate, dtShortDate, dtTime);

  TCustomDateTimePicker = class(TWinControl)
  private
    { Private declarations }
    FAppCanParse: Boolean;
    FCalendarAlign: TCalendarAlign;
    FCalendarBackground: TColor;
    FCalendarText: TColor;
    FCalendarTitleBK: TColor;
    FCalendarTitleText: TColor;
    FCalendarMonthBK: TColor;
    FCalendarTrailingText: TColor;
    FDateTimeStyle: TDateTimeStyle;
    FDateUpDown: Boolean;
    FFormat: string;
    FMaxDate: string;
    FMinDate: string;
    FOnCloseUp: TNotifyEvent;
    FOnDateTimeChange: TNotifyEvent;
    FOnDropDown: TNotifyEvent;
    szFormat: PChar;
    function GetCalendarHandle: THandle;
    function GetSystemTime: TDateTime;
    procedure SetAppCanParse(Value: Boolean);
    procedure SetCalendarAlign(Value: TCalendarAlign);
    procedure SetCalendarBackground(Value: TColor);
    procedure SetCalendarText(Value: TColor);
    procedure SetCalendarTitleBK(Value: TColor);
    procedure SetCalendarTitleText(Value: TColor);
    procedure SetCalendarMonthBK(Value: TColor);
    procedure SetCalendarTrailingText(Value: TColor);
    procedure SetDateTimeStyle(Value: TDateTimeStyle);
    procedure SetDateUpDown(Value: Boolean);
    procedure SetFormat(Value: string);
    procedure SetMinDate(Value: string);
    procedure SetMaxDate(Value: string);
    procedure SetSystemTime(Value: TDateTime);
    procedure CNNotify(var Message: TWMNotify); message CN_NOTIFY;
  protected
    { Protected declarations }
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateWnd; override;
    procedure CloseUp; dynamic;
    procedure DateTimeChange; dynamic;
    procedure DropDown; dynamic;
    property AppCanParse: Boolean read FAppCanParse write SetAppCanParse default False;
    property CalendarAlign: TCalendarAlign read FCalendarAlign write SetCalendarAlign default caLeft;
    property CalendarBackground: TColor read FCalendarBackground write SetCalendarBackground default clNone;
    property CalendarText: TColor read FCalendarText write SetCalendarText default clBlack;
    property CalendarTitleBK: TColor read FCalendarTitleBK write SetCalendarTitleBK default clNavy;
    property CalendarTitleText: TColor read FCalendarTitleText write SetCalendarTitleText default clWhite;
    property CalendarMonthBK: TColor read FCalendarMonthBK write SetCalendarMonthBK default clWhite;
    property CalendarTrailingText: TColor read FCalendarTrailingText write SetCalendarTrailingText default clBtnShadow;
    property DateTimeStyle: TDateTimeStyle read FDateTimeStyle write SetDateTimeStyle default dtLongDate;
    property DateUpDown: Boolean read FDateUpDown write SetDateUpDown default false;
    property Format: string read FFormat write SetFormat;
    property MinDate: string read FMinDate write SetMinDate;
    property MaxDate: string read FMaxDate write SetMaxDate;
    property OnCloseUp: TNotifyEvent read FOnCloseUp write FOnCloseUp;
    property OnDateTimeChange: TNotifyEvent read FOnDateTimeChange write FOnDateTimeChange;
    property OnDropDown: TNotifyEvent read FOnDropDown write FOnDropDown;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property CalendarHandle: THandle read GetCalendarHandle;
    property SystemTime: TDateTime read GetSystemTime write SetSystemTime;
    // published
  published
    { Published declarations }
  end;

  TDateTimePicker = class(TCustomDateTimePicker)
  published
    { Published declarations }
    property AppCanParse;
    property CalendarAlign;
    property CalendarBackground;
    property CalendarText;
    property CalendarTitleBK;
    property CalendarTitleText;
    property CalendarMonthBK;
    property CalendarTrailingText;
    property Color;
    property DateTimeStyle;
    property DateUpDown;
    property Enabled;
    property Font;
    property Format;
    property MaxDate;
    property MinDate;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property Visible;
    property OnCloseUp;
    property OnDateTimeChange;
    property OnDropDown;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
  end;



procedure Register;

implementation

constructor TCustomDateTimePicker.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  szFormat := StrAlloc(80);
  Height := 22;
  Width := 187;
  Color := clCaptionText;
  FCalendarBackground := clNone;
  FCalendarText :=  clBlack;
  FCalendarTitleBK := clNavy;
  FCalendarTitleText := clWhite;
  FCalendarMonthBK := clWhite;
  FCalendarTrailingText := clBtnShadow;
  FAppCanParse := False;
  FCalendarAlign := caLeft;
  FDateTimeStyle := dtLongDate;
  FDateUpDown := False;
  FFormat := '';
end;

destructor TCustomDateTimePicker.Destroy;
begin
  StrDispose(szFormat);
  inherited Destroy;
end;

procedure TCustomDateTimePicker.CreateParams(var Params: TCreateParams);
var
  ICCEX: TInitCommonControlsEx;
begin
  ICCEX.dwSize := sizeof(TInitCommonControlsEx);
  ICCEX.dwICC := ICC_DATE_CLASSES;
  InitCommonControlsEx(@ICCEX);
  inherited CreateParams(Params);
  CreateSubClass(Params, DATETIMEPICK_CLASS);
  with Params do begin
    case FDateTimeStyle of
       dtLongDate: begin
                     Style := Style or DTS_LONGDATEFORMAT;
                     if FDateUpDown then Style := Style or DTS_UPDOWN;
                     if FAppCanParse then Style := Style or DTS_APPCANPARSE;
 //                    if FCalendarAlign = caRight then Style := Style or DTS_RIGHTALIGN;
                   end;
      dtShortDate: begin
                     Style := Style or DTS_SHORTDATEFORMAT;
                     if FDateUpDown then Style := Style or DTS_UPDOWN;
                     if FAppCanParse then Style := Style or DTS_APPCANPARSE;
 //                    if FCalendarAlign = caRight then Style := Style or DTS_RIGHTALIGN;
                   end;
           dtTime: Style := Style or DTS_TIMEFORMAT;
    else
      Style := Style or DTS_LONGDATEFORMAT;
    end;
  end
end;

procedure TCustomDateTimePicker.CreateWnd;
var
  GDTR: UINT;
  MultiTime: array [0..1] of TSYSTEMTIME;
begin
  inherited CreateWnd;
  DateTime_SetMonthCalColor(Handle, MCSC_BACKGROUND, FCalendarBackground);
  DateTime_SetMonthCalColor(Handle, MCSC_TEXT, FCalendarText);
  DateTime_SetMonthCalColor(Handle, MCSC_TITLEBK, FCalendarTitleBK);
  DateTime_SetMonthCalColor(Handle, MCSC_TITLETEXT, FCalendarTitleText);
  DateTime_SetMonthCalColor(Handle, MCSC_MONTHBK, FCalendarMonthBK);
  DateTime_SetMonthCalColor(Handle, MCSC_TRAILINGTEXT, FCalendarTrailingText);
  GDTR := 0;
  if FMinDate <> '' then begin
    GDTR := GDTR or GDTR_MIN;
    MultiTime[0] := ConvertDateTimeToSystemTime(StrToDateTime(FMinDate));
  end;

  if FMaxDate <> '' then begin
    GDTR := GDTR or GDTR_MAX;
    MultiTime[1] := ConvertDateTimeToSystemTime(StrToDateTime(FMaxDate));
  end;
  DateTime_SetRange(handle, GDTR, MultiTime);

  if FFormat <> '' then begin
    StrPCopy(szFormat, FFormat);
    DateTime_SetFormat(Handle, szFormat);
  end else
    DateTime_SetFormat(Handle, nil);
end;

procedure TCustomDateTimePicker.CloseUp;
begin
  if Assigned(FOnCloseUp) then FOnCloseUp(Self);
end;

procedure TCustomDateTimePicker.DropDown;
begin
  if Assigned(FOnDropDown) then FOnDropDown(Self);
end;

procedure TCustomDateTimePicker.DateTimeChange;
begin
  if Assigned(FOnDateTimeChange) then FOnDateTimeChange(Self);
end;

procedure TCustomDateTimePicker.CNNotify(var Message: TWMNotify);
begin
  with Message.NMHdr^ do
    case Code of
             DTN_CLOSEUP: CloseUp;
      DTN_DATETIMECHANGE: DateTimeChange;
            DTN_DROPDOWN: DropDown;
//              DTN_FORMAT:
//         DTN_FORMATQUERY:
//          DTN_USERSTRING:
//           DTN_WMKEYDOWN:
    end;
end;

function TCustomDateTimePicker.GetCalendarHandle: THandle;
begin
  Result := DateTime_GetMonthCal(Handle);
end;

function TCustomDateTimePicker.GetSystemTime: TDateTime;
var
  SystemTime: TSYSTEMTIME;
  retval: DWORD;
begin
  retval := DateTime_GetSystemtime(Handle, SystemTime);
  if retval = GDT_ERROR then
    result := 0
  else
    result := ConvertSystemTimeToDataTime(SystemTime);
end;

procedure TCustomDateTimePicker.SetAppCanParse(Value: Boolean);
begin
  if Value <> FAppCanParse then begin
    FAppCanParse := Value;
    RecreateWnd;
  end;
end;

procedure TCustomDateTimePicker.SetDateTimeStyle(Value: TDateTimeStyle);
begin
  if Value <> FDateTimeStyle then begin
    FDateTimeStyle := Value;
    RecreateWnd;
  end;
end;

procedure TCustomDateTimePicker.SetDateUpDown(Value: Boolean);
begin
  if Value <> FDateUpDown then begin
    FDateUpDown := Value;
    RecreateWnd;
  end;
end;

procedure TCustomDateTimePicker.SetCalendarAlign(Value: TCalendarAlign);
begin
  if Value <> FCalendarAlign then begin
    FCalendarAlign := Value;
    RecreateWnd;
  end;
end;

procedure TCustomDateTimePicker.SetCalendarBackground(Value: TColor);
begin
  if Value <> FCalendarBackground then begin
    FCalendarBackground := Value;
    DateTime_SetMonthCalColor(Handle, MCSC_BACKGROUND, FCalendarBackground);
  end;
end;

procedure TCustomDateTimePicker.SetCalendarText(Value: TColor);
begin
  if Value <> FCalendarText then begin
    FCalendarText := Value;
    DateTime_SetMonthCalColor(Handle, MCSC_TEXT, FCalendarText);
  end;
end;

procedure TCustomDateTimePicker.SetCalendarTitleBK(Value: TColor);
begin
  if Value <> FCalendarTitleBK then begin
    FCalendarTitleBK := Value;
    DateTime_SetMonthCalColor(Handle, MCSC_TITLEBK, FCalendarTitleBK);
  end;
end;

procedure TCustomDateTimePicker.SetCalendarTitleText(Value: TColor);
begin
  if Value <> FCalendarTitleText then begin
    FCalendarTitleText := Value;
    DateTime_SetMonthCalColor(Handle, MCSC_TITLETEXT, FCalendarTitleText);
  end;
end;

procedure TCustomDateTimePicker.SetCalendarMonthBK(Value: TColor);
begin
  if Value <> FCalendarMonthBK then begin
    FCalendarMonthBK := Value;
    DateTime_SetMonthCalColor(Handle, MCSC_MONTHBK, FCalendarMonthBK);
  end;
end;

procedure TCustomDateTimePicker.SetCalendarTrailingText(Value: TColor);
begin
  if Value <> FCalendarTrailingText then begin
    FCalendarTrailingText := Value;
    DateTime_SetMonthCalColor(Handle, MCSC_TRAILINGTEXT, FCalendarTrailingText);
  end;
end;

procedure TCustomDateTimePicker.SetFormat(Value: string);
begin
  if Value <> FFormat then begin
    FFormat := Value;
    if FFormat <> '' then begin
      StrPCopy(szFormat, FFormat);
      DateTime_SetFormat(Handle, szFormat);
    end else
      DateTime_SetFormat(Handle, nil);
  end;
end;

procedure TCustomDateTimePicker.SetMinDate(Value: string);
begin
  if Value <> FMinDate then begin
    Try
      if Value <> '' then StrToDateTime(Value);
    finally
      FMinDate := Value;
    end;
  end;
end;

procedure TCustomDateTimePicker.SetMaxDate(Value: string);
begin
  if Value <> FMaxDate then begin
    Try
      if Value <> '' then StrToDateTime(Value);
    finally
      FMaxDate := Value;
    end;
  end;
end;


procedure TCustomDateTimePicker.SetSystemTime(Value: TDateTime);
var
  SystemTime: TSYSTEMTIME;
begin
  SystemTime := ConvertDateTimeToSystemTime(Value);
  DateTime_SetSystemtime(Handle, GDT_VALID, SystemTime);
  DateTimeChange;
end;

procedure Register;
begin
  RegisterComponents('Win95', [TDateTimePicker]);
end;

end.
